﻿using System;
using System.Collections;
using System.Collections.ObjectModel;
using System.Xml.Linq;

namespace WindowsFormsApplication1
{
    public class TBranch
    {
        public double min;
        public double max;
        public double purity;
        public int iclass;
        public int iProperty;
        public TBranch[] nextBranch;
        public Collection<double[]> localValues;
        const int maxRecStep = 200;  // max recursions

        public TBranch()
        {
            nextBranch = new TBranch[2];
            purity = 100;
        }

        public int CheckBranch(double[] data, int recCount = 0)
        {
            int result = -1;
            if (recCount < maxRecStep)
            {
                recCount++;
                if (purity == 0)
                {
                    if ((data[iProperty] <= max) && (data[iProperty] >= min))
                        result = iclass;
                    else
                    {
                        if (nextBranch[0] != null)
                            result = nextBranch[0].CheckBranch(data, recCount);
                    }
                }
                else
                {
                    if ((data[iProperty] <= max) && (data[iProperty] >= min) && (nextBranch[0] != null))
                        result = nextBranch[0].CheckBranch(data, recCount);
                    else
                    {
                        if ((nextBranch[1] != null) && result < 0)
                            result = nextBranch[1].CheckBranch(data, recCount);
                    }
                }
            }
            return result;
        }

        public XElement writeBranch(int index)
        {
            XElement xmlBranch = new XElement("Branch", index);
            xmlBranch.Add(new XAttribute("Class", iclass));
            xmlBranch.Add(new XAttribute("Gini", purity));
            xmlBranch.Add(new XAttribute("Min", min));
            xmlBranch.Add(new XAttribute("Max", max));
            xmlBranch.Add(new XAttribute("Property", iProperty));
            if (nextBranch[0] != null)
            {
                xmlBranch.Add(nextBranch[0].writeBranch(0));
            }
            if (nextBranch[1] != null)
            {
                xmlBranch.Add(nextBranch[1].writeBranch(1));
            }
            return xmlBranch;
        }

        public XElement loadBranch(XElement xmlBranch)
        {
            iclass = Convert.ToInt32(xmlBranch.Attribute("Class").Value);
            purity = Convert.ToDouble(xmlBranch.Attribute("Gini").Value);
            min = Convert.ToDouble(xmlBranch.Attribute("Min").Value);
            max = Convert.ToDouble(xmlBranch.Attribute("Max").Value);
            iProperty = Convert.ToInt32(xmlBranch.Attribute("Property").Value);
            IEnumerable subChields = xmlBranch.Elements("Branch");
            if (subChields != null)
            {
                foreach (XElement subelement in subChields)
                {
                    int index = Convert.ToInt32(subelement.FirstNode.ToString());
                    if ((index >= 0) && (index < nextBranch.Length))
                    {
                        nextBranch[index] = new TBranch();
                        nextBranch[index].loadBranch(subelement);
                    }
                }
            }
            return xmlBranch;
        }
    }
}
